package cn.yw.videosyncchannel.action;

 import cn.yw.videosyncchannel.service.YwvideosyncaccountService;
import cn.yw.videosyncchannel.service.YwvideosyncchannelService;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import cn.acx.IcxDacClient;
import cn.base.aspect.OperateType;
import cn.base.bean.BaseAction;
import cn.base.bean.BeanHelper;
import cn.base.excel.ExcelCol;
import cn.base.excel.ExportEngine;
import cn.base.util.CommUtils;
import cn.base.util.Constants;
import cn.base.util.DateUtil;
import cn.base.util.LogConstants;
import cn.base.util.StringUtil;
import cn.base.util.Struts2Utils;
import cn.bsystem.ptuserrole.model.PtyhBean;
import cn.ice.autoDef.PtxzsEntityArrayHolder;
import cn.ice.autoDef.SbtdspsrEntityArrayHolder;

@SuppressWarnings({"all"})
@Component("ywvideosyncchannelAction")
public class YwvideosyncchannelAction extends BaseAction{
	private static final long serialVersionUID = 1L;
	private static Logger iLog = Logger.getLogger(YwvideosyncchannelAction.class);
	
	@Autowired
	private YwvideosyncchannelService service;

	@Autowired
	private YwvideosyncaccountService ywvideosyncaccountService;
	
	/**
	 * 分页
	 */
	@OperateType(value = LogConstants.LOG_QUERY ,info ="listYwvideosyncchannelByPage")
	public void listYwvideosyncchannelByPage(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			int page = Integer.parseInt(Struts2Utils.getParameter("page"));
			int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
			int start = ( (page == 0 ?  1 : page ) - 1) * rows ;
			map.put("start",start );
			map.put("limit",rows );
			Struts2Utils.renderJson(this.service.listYwvideosyncchannelByPage(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideosyncchannelAction-listYwvideosyncchannelByPage-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}

	/**
	 * 同步设备
	 */
	public void synchronize_Ywvideosyncchannel() {
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			String username = ((PtyhBean)Struts2Utils.getSession().getAttribute("userInfo")).getYhmc();
			// 获取同步账户
			Map accountMap = ywvideosyncaccountService.get_Ywvideosyncaccount(map);
			// 获取接口数据
			map.put("yhzh", accountMap.get("syncaccount"));
//			map.put("order", " order by jdpx asc ");
			SbtdspsrEntityArrayHolder holder = new  SbtdspsrEntityArrayHolder();
	 		Date d1 = new Date();
	 		iLog.info(" dac query_Ptxzs map : "+(map.toString()));
	 		IcxDacClient client = (IcxDacClient) BeanHelper.getBean("IcxDacClient");
			int loginret = client.getDacServicePrx().queryVideoInChannelArray(map, holder);
			Date d2  = new Date();
			iLog.info(" dac query_Ptxzs query time "+(d2.getTime()-d1.getTime()));
			iLog.info("query_Ptxzs from dac ice Ret="+loginret+" size="+holder.value.length);
			List<Map> daList = new ArrayList<Map>();
			for (int i = 0; i < holder.value.length; i ++) {
				Map daMap = new HashMap();
				daMap.put("syncid",StringUtil.getUUID());
				daMap.put("videonum", holder.value[i].sbbh);
				daMap.put("channelnum", holder.value[i].tdbh);
				daMap.put("channelname", holder.value[i].tdmc);
				daMap.put("admincatalogue", holder.value[i].xzbh);
				
				daMap.put("createaccount", username);
				daMap.put("modifytime", DateUtil.currentDateTime());
				daMap.put("modifyaccount", username);
				daMap.put("createtime", DateUtil.currentDateTime());
				daList.add(daMap);
			}
			this.service.batch_insert_Ywvideosyncchannel(daList);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideosyncchannelAction-synchronize_Ywvideosyncchannel-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 查询总数
	 */
	/*
	//@OperateType(value = LogConstants.LOG_QUERY ,info ="count_Ywvideosyncchannel")
	public void count_Ywvideosyncchannel(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.count_Ywvideosyncchannel(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideosyncchannelAction-count_Ywvideosyncchannel-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 查询 Ywvideosyncchannel
	 */
	/*
	@OperateType(value = LogConstants.LOG_GET ,info ="query_Ywvideosyncchannel")
	public void query_Ywvideosyncchannel(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.query_Ywvideosyncchannel(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideosyncchannelAction-query_Ywvideosyncchannel-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 查询 一条Ywvideosyncchannel
	 */
	/*
	@OperateType(value = LogConstants.LOG_GET ,info ="get_Ywvideosyncchannel")
	public void get_Ywvideosyncchannel(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.get_Ywvideosyncchannel(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideosyncchannelActionquery_Ywvideosyncchannel-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 删除
	 */
	@OperateType(value = LogConstants.LOG_DELETE ,info ="deleteYwvideosyncchannel")
	public void delete_Ywvideosyncchannel(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(!CommUtils.isEmpty(map)){
				int result = service.delete_Ywvideosyncchannel(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}else{
				 throw new Exception("请正确的选择删除记录!!!");
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideosyncchannelAction-delete_Ywvideosyncchannel-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}

	/**
	 * 插入
	 */
	@OperateType(value = LogConstants.LOG_ADD ,info ="insert_Ywvideosyncchannel")
	public void insert_Ywvideosyncchannel(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(StringUtil.checkEmpty(map.get("syncid"))){
				map.put("syncid",StringUtil.getUUID());
			}
			if(!StringUtil.checkEmpty(map.get("checkparam"))){
				Map sMap = new HashMap();
				sMap.put("tableparam", map.get("checkparam"));
				List ls = service.query_Ywvideosyncchannel(sMap);
				if(!StringUtil.checkEmpty(ls)||ls.size()>0){
					Struts2Utils.renderJson(Constants.SAME);
				}else{
					service.insert_Ywvideosyncchannel(map);
					Struts2Utils.renderJson(Constants.SUCCESS);
				}
			}else{
				service.insert_Ywvideosyncchannel(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}			
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideosyncchannelAction-insert_Ywvideosyncchannel()-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 修改
	 */
	@OperateType(value = LogConstants.LOG_UPDATE ,info ="update_Ywvideosyncchannel")
	public void update_Ywvideosyncchannel(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(!StringUtil.checkEmpty(map.get("checkparam"))){
				Map sMap = new HashMap();
				sMap.put("tableparam", map.get("checkparam"));
				List ls = service.query_Ywvideosyncchannel(sMap);
				if(!StringUtil.checkEmpty(ls)||ls.size()>0){
					Struts2Utils.renderJson(Constants.SAME);
				}else{
					int result = service.update_Ywvideosyncchannel(map);
					Struts2Utils.renderJson(Constants.SUCCESS);
				}
			}else{
				int result = service.update_Ywvideosyncchannel(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideosyncchannelAction-update_Ywvideosyncchannel-error: " +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 批量删除
	 */
	/*
	@OperateType(value = LogConstants.LOG_DELETE ,info ="batch_delete_Ywvideosyncchannel")
	public void batch_delete_Ywvideosyncchannel(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Map m = new HashMap();
			m.put("keyword", map.get("keyword").toString());
			int result = service.batch_delete_Ywvideosyncchannel(m);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideosyncchannelAction-batch_delete_Ywvideosyncchannel-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	*/
	
	/**
	 * 导出Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_EXPORT ,info ="exp_Ywvideosyncchannel")
	public void exp_Ywvideosyncchannel(){
		try {
			Map map = Struts2Utils.getRequestParameterMap();
			map.put("start",0 );
			map.put("limit",5000);
			List<Map> sList = service.query_Ywvideosyncchannel(map);		
			List<HashMap> expList = new ArrayList<HashMap>();
			for(Map m : sList){
				Map exportMap = new HashMap();
				exportMap.put("yhzh", m.get("yhzh"));
				expList.add((HashMap) exportMap);
			}
			int excelNum = 2;
			ExcelCol[] cells = new ExcelCol[excelNum];
			String[] zdbm = {"yhzh", "yhmc",};
			String[] zdmc = {"用户账号", "用户名称"};
			for(int i=0;i<excelNum;i++){
				cells[i] = new ExcelCol();
				cells[i].setColKey(zdbm[i]);
				cells[i].setColName(zdmc[i]);
			}		
			SimpleDateFormat formart = new SimpleDateFormat("yyyy-MM-dd");   
        	String dateTime=formart.format(new Date()); 
			Map params = new HashMap();
			params.put("fileName", "运维监控同步通道数据-"+dateTime);
			params.put("sheetName", "运维监控同步通道数据");
			params.put("header", "运维监控同步通道数据");	
			new ExportEngine().exportCommData(params, cells, (ArrayList)map.get("rows"), Struts2Utils.getResponse());
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideosyncchannelAction-exoprtExcel-error:" +e);
			
		}
	}
	*/
	
	/**
	 * 导入Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_IMPORT ,info ="imp_Ywvideosyncchannel")
	public String imp_Ywvideosyncchannel(String excelFile,Object user) {
		String rs = "导入格式有误!";
		int rowNum = 0;
		int dataCount = 0;
		int successNum = 0;
		int repeatNum = 0;
		int failNum = 0;
		try {
		
			ExcelReader readExcel = new ExcelReader();
			readExcel.openFile(excelFile);
			readExcel.setSheetNum(0);
			int count = readExcel.getRowCount();
			iLog.info("总行数count--->" + count);
			rs = " 导入数据成功！总共"+ dataCount +"条数据,重复"+repeatNum+"条数据！失败"+failNum+"条数据!";
			File file = new File(excelFile);
			if(file.exists()){
				file.delete();
			}
		} catch (Exception e) {
			if (rowNum > 3) {
				rs = "资源部分导入(更新)失败！Excel第" + rowNum + "行起未导入(更新)成功！";
			} else {
				rs = "资源导入(更新)失败！";
			}
			iLog.error("YwvideosyncchannelAction-imp_Ywvideosyncchannel-error:" +e);
			e.printStackTrace();
		}		
		return rs;
	}
	*/
}
